unit demo_unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  StdCtrls, ExtCtrls, Dialogs;

type
  TEffectProgress = procedure(Sender: TObject; Percent: Integer) of object;
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Panel1: TPanel;
    Panel2: TPanel;
    ColorDialog1: TColorDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Panel1Click(Sender: TObject);
    procedure Panel2Click(Sender: TObject);
  private
    procedure DoProgress(Sender: TObject; Percent: Integer);
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
type
  TSuperNova = function(Bmp: TBitmap; AColor: TColor; cx, cy, Radius, Spokes,
                         RandomHue: Integer; Progress: TEffectProgress): Boolean; 
var
  Bmp: TBitmap;
  hNova: HINST;
  SuperNova: TSuperNova;
begin
  Bmp := TBitmap.Create;
  try
    with Bmp do
    begin
      PixelFormat := pf24bit;
      Width  := Image1.Width;
      Height := Image1.Height;
      Canvas.Brush.Color := Panel2.Color;
      Canvas.FillRect(Rect(0, 0, Width, Height));
    end;
    hNova := LoadLibrary('NOVA.DLL');
    if hNova = 0 then Exit;
    try
      @SuperNova := GetProcAddress(hNova, 'SuperNova');
      if @SuperNova = nil then Exit;
      if SuperNova(Bmp,
                   Panel1.Color,
                   Image1.Width div 2,
                   Image1.Height div 2,
                   StrToInt(Edit1.Text),
                   StrToInt(Edit2.Text),
                   StrToInt(Edit3.Text),
                   DoProgress
                  ) then
        Image1.Picture.Bitmap.Assign(Bmp);
    finally
      FreeLibrary(hNova);
    end;
  finally
    Bmp.Free;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Panel1Click(Sender: TObject);
begin
  ColorDialog1.Color := Panel1.Color;
  if ColorDialog1.Execute then
    Panel1.Color := ColorDialog1.Color;
end;

procedure TForm1.Panel2Click(Sender: TObject);
begin
  ColorDialog1.Color := Panel2.Color;
  if ColorDialog1.Execute then
    Panel2.Color := ColorDialog1.Color;
end;

procedure TForm1.DoProgress(Sender: TObject; Percent: Integer);
begin
  Caption := Format('%d %% done.', [Percent]);
end;

end.
